unit UfrmAbout;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TfrmAbout = class(TForm)
    btnOk: TButton;
    lblMail: TLabel;
    lblInternet: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure lblMailClick(Sender: TObject);
    procedure lblInternetClick(Sender: TObject);
    procedure lblInternetMouseEnter(Sender: TObject);
    procedure lblInternetMouseLeave(Sender: TObject);
    procedure lblMailMouseEnter(Sender: TObject);
    procedure lblMailMouseLeave(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  procedure AboutDlgExec;

implementation

{$R *.dfm}

uses
  ShellApi, Vcl.GraphUtil;

resourcestring
  rsAuthor = ' ..';

procedure AboutDlgExec;
var
  frmAbout: TfrmAbout;
begin
  frmAbout:= TfrmAbout.Create(Application);
  try
    frmAbout.ShowModal;
  finally
    frmAbout.Free;
  end;
end;

procedure TfrmAbout.FormCreate(Sender: TObject);
begin
  Caption:= Format('  %s', [Application.Title]);
end;

procedure TfrmAbout.FormPaint(Sender: TObject);

  procedure BevelLine(C: TColor; X1, Y1, X2, Y2: Integer);
  begin
    with Canvas do
    begin
      Pen.Color := C;
      MoveTo(X1, Y1);
      LineTo(X2, Y2);
    end;
  end;

var
  R: TRect;
  M: TMemoryStatusEx;
begin
  SetBkMode(Canvas.Handle, TRANSPARENT);
  Canvas.Font.Size:= 8;
  //
  R:= Rect(0, 0, ClientWidth, 56);
  GradientFillCanvas(Canvas, TColor($00FFFF), TColor($00CC00), R, gdHorizontal);
  //
  BevelLine(clBtnShadow, 0, 56, ClientWidth, 56);
  BevelLine(clBtnHighlight, 0, 57, ClientWidth, 57);
  //
  Canvas.Draw(12, 12, Application.Icon);
  //
  Canvas.Font.Style:= [fsBold];
  Canvas.TextOut(56, 12, Application.Title);
  Canvas.Font.Style:= [];
  //
  Canvas.TextOut(56, 28, ' 1.0, 2016');
  //
  Canvas.TextOut(56, 76, Chr(169) + ' ' + rsAuthor);
  Canvas.TextOut(188, 76, 'Email:');
  Canvas.TextOut(56, 96, ' .');
  Canvas.TextOut(188, 96, 'Internet:');
  //
  M.dwLength:= SizeOf(TMemoryStatusEx);
  GlobalMemoryStatusEx(M);
  Canvas.TextOut(56, 132, FormatFloat('"  : "#,###" "', M.ullTotalPhys div 1024));
  //
  BevelLine(clBtnShadow, 0, 160, ClientWidth, 160);
  BevelLine(clBtnHighlight, 0, 161, ClientWidth, 161);
end;

procedure TfrmAbout.lblMailClick(Sender: TObject);
begin
  ShellExecute(Handle, nil, PChar('mailto:' + (Sender as TLabel).Caption), nil, nil, SW_SHOW);
end;

procedure TfrmAbout.lblInternetClick(Sender: TObject);
begin
  ShellExecute(Handle, nil, PChar((Sender as TLabel).Caption), nil, nil, SW_SHOW);
end;

procedure TfrmAbout.lblInternetMouseEnter(Sender: TObject);
begin
  (Sender as TLabel).Font.Style:= [fsUnderline];
end;

procedure TfrmAbout.lblInternetMouseLeave(Sender: TObject);
begin
  (Sender as TLabel).Font.Style:= [];
end;

procedure TfrmAbout.lblMailMouseEnter(Sender: TObject);
begin
  (Sender as TLabel).Font.Style:= [fsUnderline];
end;

procedure TfrmAbout.lblMailMouseLeave(Sender: TObject);
begin
  (Sender as TLabel).Font.Style:= [];
end;

end.
