unit UfrmFileOptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Progs;

type
  TfrmFileOptions = class(TForm)
    lblVersion: TLabel;
    lblDate: TLabel;
    dtpDate: TDateTimePicker;
    edVersion: TEdit;
    udVersion: TUpDown;
    memComment: TMemo;
    lblComment: TLabel;
    btnCancel: TButton;
    btnOk: TButton;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function EditFileOptions: Boolean;

implementation

{$R *.dfm}

function EditFileOptions: Boolean;
var
  frmFileOptions: TfrmFileOptions;
  nYear, nMonth, nDay: Word;
begin
  frmFileOptions:= TfrmFileOptions.Create(Application.MainForm);
  with frmFileOptions do
  begin
    try
      Result:= ShowModal = mrOk;
      if Result then
        with LelFileHeader do
        begin
          DecodeDate(dtpDate.Date, nYear, nMonth, nDay);
          Day:= nDay;
          Month:= nMonth;
          Year:= nYear;
          Version:= udVersion.Position;
          Comment:= AnsiString(Copy(memComment.Lines.Text, 1, MAX_CMNT_LEN));
        end;
    finally
      Free;
    end;
  end;
end;

procedure TfrmFileOptions.FormCreate(Sender: TObject);
begin
  with LelFileHeader do
  begin
    dtpDate.Date:= EncodeDate(Year, Month, Day);
    udVersion.Position:= Version;
    memComment.Lines.Text:= Comment;
  end;
end;

end.
