unit UfrmPreview;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Progs, Vcl.ExtCtrls, Vcl.Menus;

type
  TfrmPreview = class(TForm)
    ScrollBox1: TScrollBox;
    PaintBox1: TPaintBox;
    PopupMenu1: TPopupMenu;
    pmSaveAs: TMenuItem;
    procedure PaintBox1Paint(Sender: TObject);
    procedure pmSaveAsClick(Sender: TObject);
  private
    { Private declarations }
    FProgList: TProgList;
  public
    { Public declarations }
  end;

  function Preview(AProgList: TProgList): Boolean;

implementation

{$R *.dfm}

resourcestring
  rsEmfFilter = 'Windows Enhanced MetaFiles (*.emf)|*.emf';
  rsDefaultEmfExt = 'emf';

function Preview(AProgList: TProgList): Boolean;
var
  frmPreview: TfrmPreview;
begin
  frmPreview:= TfrmPreview.Create(Application.MainForm);
  with frmPreview do
  begin
    try
      FProgList:= AProgList;
      Caption:= FProgList.FileName;
      AProgList.Draw();
      PaintBox1.Width:= AProgList.Picture.Width;
      PaintBox1.Height:= AProgList.Picture.Height;
      PaintBox1.Invalidate;
      Result:= ShowModal = mrOk;
      if Result then
      begin
      end;
    finally
      Free;
    end;
  end;
end;

procedure TfrmPreview.PaintBox1Paint(Sender: TObject);
begin
  PaintBox1.Canvas.Draw(0, 0, FProgList.Picture);
end;

procedure TfrmPreview.pmSaveAsClick(Sender: TObject);
begin
  with TSaveDialog.Create(Self) do
  begin
    Filter:= rsEmfFilter;
    DefaultExt:= rsDefaultEmfExt;
    Options:= [ofHideReadOnly, ofOverwritePrompt, ofEnableSizing];
    FileName:= ChangeFileExt(FProgList.FileName, '');
    if not Execute then Exit;
    FProgList.Picture.SaveToFile(FileName);
  end;
end;

end.
